/**
 * Example using the Ketai library (http://KetaiProject.org)
 *
 * Display accelerometer, orientation and light sensor data.
 *
 * Revision 1.0, Updated: 2016-02-12 P. Peters
 * Originated from the Accelerometer example in the Ketai library
 */

import ketai.sensors.*;

KetaiSensor sensor;

// variables to hold the accelerometer x, y and z, values
float accelerometerX, accelerometerY, accelerometerZ;
// variables to hold the orientation x, y and z, values
float orientationX, orientationY, orientationZ;
// variable to hold te light sensor value
float lightval;

void setup()
{
  // create and start KetaiSensor object
  sensor = new KetaiSensor(this);
  sensor.start();
  
  orientation(LANDSCAPE);
  textAlign(CENTER, CENTER);
  textSize(36);
}

void draw()
{
  background(78, 93, 75);
  // display accelerometer sensor values
  text("Accelerometer: \n" + 
    "x: " + nfp(accelerometerX, 1, 3) + "\n" +
    "y: " + nfp(accelerometerY, 1, 3) + "\n" +
    "z: " + nfp(accelerometerZ, 1, 3), 0, 0, width, height/3);
  // display orientation sensor values
  text("Orientation: \n" + 
    "x: " + nfp(orientationX, 1, 3) + "\n" +
    "y: " + nfp(orientationY, 1, 3) + "\n" +
    "z: " + nfp(orientationZ, 1, 3), 0, height/3, width, height/3);
  // display light sensor value  
  text("Light: \n" + 
    "t: " + nfp(lightval, 1, 3), 0, 2*height/3, width, height/3);
}

// if accelerometer sensor values change you will come here
void onAccelerometerEvent(float x, float y, float z)
{
  accelerometerX = x;
  accelerometerY = y;
  accelerometerZ = z;
}

// if orientation sensor values change you will come here
void onOrientationEvent(float x, float y, float z)
{
  orientationX = x;
  orientationY = y;
  orientationZ = z;
}

// if light sensor value changes you will come here
void onLightEvent(float d)
{
  lightval = d;
}