/*
 * The canvas holds all the gui elements and redirects the mouse
 * events to each and every gui element
 */

class Canvas {
  // arraylist holding the gui elements
  ArrayList<GuiElement> _elements;

  Canvas() {
    // create an empty arrylist to hold the gui elements
    _elements = new ArrayList();
  }

  // add a gui element to the arraylist and assign an id
  void add(GuiElement e) {
    _elements.add(e);
    e.setId(_elements.size());
  }

  // get gui element at arraylist position i
  GuiElement get(int i) {
    return _elements.get(i);
  }

  // draw all elements in the arraylist
  void draw() {
    for (int i = _elements.size()-1; i >= 0; i--)
      get(i).draw();
  }

  // check all elements. For the elements the mouse pointer is clicked in 
  // the callback function is performed  
  void mouseClick() {
    for (int i = _elements.size()-1; i >= 0; i--)
      if (_elements.get(i).mouseIn(mouseX, mouseY)) {
        _elements.get(i).mouseClick();
      }
  }

  // check all elements. For the elements the mouse pointer is pressed in 
  // the callback function is performed
  // the press is remembered
  void mousePress() {
    for (int i = _elements.size()-1; i >= 0; i--)
      if (_elements.get(i).mouseIn(mouseX, mouseY)) {
        _elements.get(i).mousePress();
      }
  }

  // check all elements. For the elements the mouse pointer is released in 
  // this is remembered
  void mouseRelease() {
    for (int i = _elements.size()-1; i >= 0; i--)
      if (_elements.get(i).mouseIn(mouseX, mouseY)) {
        _elements.get(i).mouseRelease();
      }
  }

  // check all elements. For the elements the mouse pointer is moved in 
  void mouseMove() {
    for (int i = _elements.size()-1; i >= 0; i--)
      if (_elements.get(i).mouseIn(mouseX, mouseY)) {
        _elements.get(i).mouseMove();
      }
  }
  
    // check all elements. For the elements the mouse pointer is moved in 
  void mouseDrag() {
    for (int i = _elements.size()-1; i >= 0; i--)
      if (_elements.get(i).mouseIn(mouseX, mouseY)) {
        _elements.get(i).mouseDrag();
      }
  }
}