// Circular button gui element

class CircleButton extends GuiElement {
  int textSz = 40;
  // remember if up or down
  boolean _up = true;
  // width of the circlebutton
  int _w = -1;
  // 'up' color
  int _color = -1;
  String _txt;

  /*
   * Create circular button gui element
   * Parameters:
   *
   * x,y: position on screen
   * w: width of circlebutton
   * cb: callback listener
   */
  CircleButton(int x, int y, int w, int col, CallBack cb) {
    // call superclass constructor to set x,y and callback
    super(x, y, cb);
    _w = w;
    _color = col;
    _txt = "";
  }

  // Check if mx,my is inside the gui element surface
  boolean mouseIn(int mx, int my) {
    int r = _w/2;
    return ((mx > _x-r) && (mx < _x+r) && (my > _y-r) && (my < _y+r));
  }

  // perform draw actions
  void draw() {
    _up = getUp();
    if (_up)
      drawup();
    else
      drawdown();
    if (_txt != "") {
      fill(0);
      textSize(textSz);
      text(_txt, _x-textWidth(_txt)/2, _y+textSz/2);
    }
  }

  // draw gui element 'up' position
  void drawup() {
    fill(_color);
    ellipse(_x, _y, _w, _w);
  }

  // draw gui element 'down' position
  void drawdown() {
    fill(_color+100);
    ellipse(_x, _y, _w, _w);
  }

  // set text string to be displayed in the gui element
  void setText(String txt) {
    _txt = txt;
  }
}