class GuiElement {
  boolean _md;
  int _id = -1;
  int _x = -1;
  int _y = -1;
  CallBack _cb;

  GuiElement(int x, int y, CallBack cb) {
    _x = x;
    _y = y;
    _cb = cb;
    _md = false;
  }

  void draw() {
    println(getClass() + " Draw unimplemented");
  }

  void drawup() {
    println(getClass() + " Drawup unimplemented");
  }

  void drawdown() {
    println(getClass() + " Drawdown unimplemented");
  }

  boolean mouseIn(int mx, int my) {
    println(getClass() + " mouseIn unimplemented");
    return false;
  }

  boolean getUp() {
    return ! _md;
  }

  int getId() {
    return _id;
  }

  void setId(int id) {
    _id = id;
  }

  void doCallBack() {
    _cb.actionListener();
  }

  void mousePress() {
    _md = true;
  } 

  void mouseRelease() {
    _md = false;
    doCallBack();
  } 

  void mouseClick() {
  }

  void mouseMove() {
  }
  
  void mouseDrag() {
  }
}