/*
 * Simple gui elements implemented in an Object Oriented way
 *
 * this is by no means perfect or complete, it just demonstrates the amount 
 * of effort it takes to create simple gui elements
 *
 * Revision 0.1; February 13, 2016
 * Author P.Peters
 */
 
// Canvas holding the GUI elements
Canvas canvas;

// Gui elements
RectangleButton rb;
CircleButton rb1;
Slider s1;

// initialisation
void setup() {
  // for testing purposes in Java mode the 'size' method is needed
  //size(800, 800);
  
  // create canvas
  canvas = new Canvas();
  // create GUI elements
  rb = new RectangleButton(20, 20, 500, 150, 150, 
    new CallBack() { 
    public void actionListener() {
      println("button "+rb.getId());
    }
  }
  );
  rb1 = new CircleButton(250, 300, 200, 150, 
    new CallBack() { 
    public void actionListener() {
      println("button "+rb1.getId());
    }
  }
  );
    s1 = new Slider(20, 500, 500, 150, 
    new CallBack() { 
    public void actionListener() {
      println("slider "+s1.getId()+": "+s1.getValue());
    }
  }
  );
  // add gui elements to the canvas
  canvas.add(rb);
  canvas.add(rb1);
  canvas.add(s1);
  // set text of tectangular button
  // use of getId should be AFTER adding to canvas because that
  // is when the Id is assigned..
  rb.setText("Btn "+rb.getId());
  rb1.setText("Btn "+rb.getId());
}

void draw() {
  // draw elements on the canvas
  canvas.draw();
}

// all mouse events are redirected to the canvas
void mousePressed() {
  canvas.mousePress();
}

void mouseReleased() {
  canvas.mouseRelease();
}

void mouseClicked() {
  canvas.mouseClick();
}

void mouseMoved() {
  canvas.mouseMove();
}

void mouseDragged() {
  canvas.mouseDrag();
}